## carbon-gtk2 0+p20201123+git20201207.1945

=== CMakeLists.txt ===
project( carbon-gtk )

cmake_minimum_required(VERSION 2.4)

###########################
# Define package generation
###########################

set( CPACK_PACKAGE_NAME "carbon-gtk2" )
set( CPACK_SOURCE_PACKAGE_NAME "carbon-gtk2" )
set( CPACK_SOURCE_GENERATOR TBZ2 )
set( CPACK_PACKAGE_DESCRIPTION_SUMMARY "Carbon Gtk2 theme" )
set( CPACK_PACKAGE_VENDOR "hugo.pereira@free.fr" )
set( CPACK_PACKAGE_VERSION_MAJOR "1" )
set( CPACK_PACKAGE_VERSION_MINOR "4" )
set( CPACK_PACKAGE_VERSION_PATCH "50" )
set( CPACK_SOURCE_IGNORE_FILES "build" "^${PROJECT_SOURCE_DIR}.*/.git/" )

##################################
# Define carbon-gtk version string
##################################
if( EXISTS "${CMAKE_SOURCE_DIR}/.git" )
    execute_process(COMMAND sh -c "cd ${CMAKE_SOURCE_DIR} && git describe 2>/dev/null"
        OUTPUT_VARIABLE CARBON_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE)
endif( EXISTS "${CMAKE_SOURCE_DIR}/.git" )
STRING(COMPARE NOTEQUAL "${CARBON_VERSION}" "" CARBON_VERSION_DETECTED )
if( NOT CARBON_VERSION_DETECTED )
    set( CARBON_VERSION ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH} )
endif( NOT CARBON_VERSION_DETECTED )
message( "Detected carbon version string: ${CARBON_VERSION}" )

set( CPACK_SOURCE_PACKAGE_FILE_NAME "carbon-gtk2-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}" )
include( CPack )
########################
# Package specific flags
########################

# Set to 1 to enable debugging information
if( NOT DEFINED CARBON_DEBUG )
    set( CARBON_DEBUG 0 )
endif( NOT DEFINED CARBON_DEBUG )

# Set to 1 to disable all signal hooks used for various features
if( NOT DEFINED DISABLE_SIGNAL_HOOKS )
    set( DISABLE_SIGNAL_HOOKS 0 )
endif( NOT DEFINED DISABLE_SIGNAL_HOOKS )

# Set to 1 to enable debug logs regarding inner shadows
if( NOT DEFINED CARBON_DEBUG_INNERSHADOWS )
    set( CARBON_DEBUG_INNERSHADOWS 0 )
endif( NOT DEFINED CARBON_DEBUG_INNERSHADOWS )

# Set to 1 to build windeco test app (normal users rarely need this)
if( NOT DEFINED BUILD_DECO_TEST )
    set( BUILD_DECO_TEST 0 )
endif( NOT DEFINED BUILD_DECO_TEST )

# Set to 1 to replace gtk stock icons
# with carbon-icons
if( NOT DEFINED CARBON_ICON_HACK )
    set( CARBON_ICON_HACK 1 )
endif( NOT DEFINED CARBON_ICON_HACK )

# Set to 1 to force KDE icons and fonts when running in non-KDE
if( NOT DEFINED CARBON_FORCE_KDE_ICONS_AND_FONTS )
    set( CARBON_FORCE_KDE_ICONS_AND_FONTS 1 )
endif( NOT DEFINED CARBON_FORCE_KDE_ICONS_AND_FONTS )

# Set to 1 to resize combobox list to compensate for combobox button glow width
# (may result in flicker on combo popup)
if( NOT DEFINED ENABLE_COMBOBOX_LIST_RESIZE )
    set( ENABLE_COMBOBOX_LIST_RESIZE 1 )
endif( NOT DEFINED ENABLE_COMBOBOX_LIST_RESIZE )

# Set to 0 to disable inner shadows hack
# Note this flag is automatically set to 0 if GTK version is too old (< 2.24.2)
if( NOT DEFINED ENABLE_INNER_SHADOWS_HACK )
    set( ENABLE_INNER_SHADOWS_HACK 1 )
endif( NOT DEFINED ENABLE_INNER_SHADOWS_HACK )

# set to 0 to disable groupbox hack
if( NOT DEFINED ENABLE_GROUPBOX_HACK )
    set( ENABLE_GROUPBOX_HACK 1 )
endif( NOT DEFINED ENABLE_GROUPBOX_HACK )

##############
# Requirements
##############

# install prefix
include( UsePkgConfig )
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

    exec_program(
        ${PKGCONFIG_EXECUTABLE}
        ARGS --variable=prefix gtk+-2.0
        OUTPUT_VARIABLE GTK_PREFIX )

    message( "Info: using PKGCONFIG_EXECUTABLE to set the installation prefix" )
    set(CMAKE_INSTALL_PREFIX
        ${GTK_PREFIX} CACHE PATH "GTK install prefix" FORCE
        )
endif()

# X11
find_package( X11 REQUIRED )

# PKG_CONFIG
find_package(PkgConfig REQUIRED )

# GTK
pkg_check_modules( GTK REQUIRED gtk+-2.0 )
add_definitions( ${GTK_CFLAGS_OTHER} )

# Cairo
pkg_check_modules( CAIRO REQUIRED cairo )
add_definitions( ${CAIRO_CFLAGS_OTHER} )

##########################
# installation directories
##########################
exec_program(
    ${PKGCONFIG_EXECUTABLE}
    ARGS --variable=gtk_binary_version gtk+-2.0
    OUTPUT_VARIABLE GTK_BIN_VERSION )

if( DEFINED LIB_SUFFIX OR NOT CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT )

    message( "Info: using LIB_SUFFIX to set the theme engine installation path" )
    set( INSTALL_PATH_GTK_ENGINES "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/gtk-2.0/${GTK_BIN_VERSION}/engines" CACHE PATH "The directory in which to install the theme engine library( eg. /usr/lib/gtk-2.0/2.4.0/engines )" )

else()

    exec_program(
        ${PKGCONFIG_EXECUTABLE}
        ARGS --variable=libdir gtk+-2.0
        OUTPUT_VARIABLE GTK_LIBDIR_PREFIX )

    message( "Info: using PKGCONFIG_EXECUTABLE to set the theme engine installation path" )
    set( INSTALL_PATH_GTK_ENGINES "${GTK_LIBDIR_PREFIX}/gtk-2.0/${GTK_BIN_VERSION}/engines" CACHE PATH "The directory in which to install the theme engine library( eg. /usr/lib/gtk-2.0/2.4.0/engines )" )

endif()

set( INSTALL_PATH_GTK_THEMES "${CMAKE_INSTALL_PREFIX}/share/themes" CACHE PATH "The directory in which to install the theme data( eg. /usr/share/themes )" )
set( GTK_THEME_DIR ${INSTALL_PATH_GTK_THEMES}/carbon-gtk )

# First emit all warnings in one place
# Adjust flags based on gtk version and warn user if needed
if( ENABLE_INNER_SHADOWS_HACK AND GTK_VERSION VERSION_LESS 2.24.2 )
    message( "Warning: disabling inner shadows hack because GTK version is too old (needed 2.24.2, found ${GTK_VERSION})" )
    set( ENABLE_INNER_SHADOWS_HACK 0 )
endif( ENABLE_INNER_SHADOWS_HACK AND GTK_VERSION VERSION_LESS 2.24.2 )

#########
# summary
#########
message( "Flags: " )
message( "  CARBON_DEBUG ${CARBON_DEBUG}" )
message( "  DISABLE_SIGNAL_HOOKS ${DISABLE_SIGNAL_HOOKS}" )
message( "  BUILD_DECO_TEST ${BUILD_DECO_TEST}" )
message( "  CARBON_DEBUG_INNERSHADOWS ${CARBON_DEBUG_INNERSHADOWS}" )
message( "  CARBON_ICON_HACK ${CARBON_ICON_HACK}" )
message( "  CARBON_FORCE_KDE_ICONS_AND_FONTS ${CARBON_FORCE_KDE_ICONS_AND_FONTS}" )
message( "  ENABLE_COMBOBOX_LIST_RESIZE ${ENABLE_COMBOBOX_LIST_RESIZE}" )
message( "  ENABLE_INNER_SHADOWS_HACK ${ENABLE_INNER_SHADOWS_HACK}" )
message( "  ENABLE_GROUPBOX_HACK ${ENABLE_GROUPBOX_HACK}" )
message( "" )
message( "Paths: " )
message( "  Installing the GTK theme engine library to: ${INSTALL_PATH_GTK_ENGINES}" )
message( "  Installing the GTK theme engine data to: ${GTK_THEME_DIR}" )
message( "" )

##################
# uninstall target
##################
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)


######################################################################
# Setup definitions and directories to be used for linking and include
######################################################################
link_directories( ${GTK_LIBRARY_DIRS} ${CAIRO_LIBRARY_DIRS} )
include_directories( ${GTK_INCLUDE_DIRS} ${CAIRO_INCLUDE_DIRS} ${X11_X11_INCLUDE_PATH} )

#############################
# generate configuration file
#############################
configure_file( config.h.cmake ${CMAKE_BINARY_DIR}/config.h )

################
# Subdirectories
################
add_subdirectory( src )
add_subdirectory( rc )
add_subdirectory( special-icons )
add_subdirectory( demo )

=== demo/CMakeLists.txt ===
# For config.h to be available
include_directories( ${CMAKE_BINARY_DIR} )

########### next target ###############
set( carbon_gtk_demo_SOURCES
    carbonbuttondemowidget.cpp
    carbondemodialog.cpp
    carbondemowidget.cpp
    carbonframedemowidget.cpp
    carboninfowidget.cpp
    carboninputdemowidget.cpp
    carbonlistdemowidget.cpp
    carbonsignal.cpp
    carbonsignalhandler.cpp
    carbonsliderdemowidget.cpp
    carbontimer.cpp
    carbontabdemowidget.cpp
    carbonversion.cpp
    carbongtkdemo_main.cpp
 )

IF( WIN32 )
    add_executable( carbon-gtk-demo WIN32 ${carbon_gtk_demo_SOURCES} )
ELSE( WIN32 )
    add_executable( carbon-gtk-demo ${carbon_gtk_demo_SOURCES} )
ENDIF( WIN32 )

target_link_libraries( carbon-gtk-demo ${GTK_LIBRARIES} ${CAIRO_LIBRARIES} ${X11_X11_LIB} )
install( TARGETS carbon-gtk-demo DESTINATION ${CMAKE_INSTALL_PREFIX}/bin )

########### next target ###############
if( BUILD_DECO_TEST )
    set( deco_test_SOURCES carbonversion.cpp carbongtkdeco_main.cpp )
    add_executable( carbon-gtk-deco ${deco_test_SOURCES} )
    target_link_libraries( carbon-gtk-deco ${GTK_LIBRARIES} ${CAIRO_LIBRARIES} ${X11_X11_LIB} ${CMAKE_DL_LIBS} )
    install( TARGETS carbon-gtk-deco DESTINATION ${CMAKE_INSTALL_PREFIX}/bin )
endif( BUILD_DECO_TEST )

=== rc/CMakeLists.txt ===

install(
	FILES gtkrc icons4 kdeglobals carbonrc argb-apps.conf
	DESTINATION "${GTK_THEME_DIR}/gtk-2.0"
 )

=== src/CMakeLists.txt ===
include_directories( ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_BINARY_DIR} )
include_directories( animations debug )

# Sources
# please keep this list alphabetically sorted for clarity
set( carbon_gtk_SOURCES
    animations/carbonanimations.cpp
    animations/carbonarrowstatedata.cpp
    animations/carbonbackgroundhintengine.cpp
    animations/carbonbaseengine.cpp
    animations/carboncomboboxdata.cpp
    animations/carboncomboboxentrydata.cpp
    animations/carbondialogengine.cpp
    animations/carbonflatwidgetengine.cpp
    animations/carbonfollowmousedata.cpp
    animations/carbonhook.cpp
    animations/carbonhoverdata.cpp
    animations/carboninnershadowdata.cpp
    animations/carbonmainwindowdata.cpp
    animations/carbonmenubarstatedata.cpp
    animations/carbonmenustatedata.cpp
    animations/carbonmenuitemengine.cpp
    animations/carbonmenuitemdata.cpp
    animations/carbonpaneddata.cpp
    animations/carbonsignal.cpp
    animations/carbonscrollbardata.cpp
    animations/carbonscrollbarstatedata.cpp
    animations/carbonscrolledwindowdata.cpp
    animations/carbontabwidgetdata.cpp
    animations/carbontabwidgetstatedata.cpp
    animations/carbontimeline.cpp
    animations/carbontimelineserver.cpp
    animations/carbontimer.cpp
    animations/carbontoolbarstatedata.cpp
    animations/carbontreeviewdata.cpp
    animations/carbontreeviewengine.cpp
    animations/carbontreeviewstatedata.cpp
    animations/carbonwidgetsizedata.cpp
    animations/carbonwidgetstatedata.cpp
    animations/carbonwidgetstateengine.cpp
    debug/carbonwidgetexplorer.cpp
    carbonapplicationname.cpp
    carbonargbhelper.cpp
    carboncairocontext.cpp
    carboncairoutils.cpp
    carboncoloreffect.cpp
    carboncolorutils.cpp
    carbonfontinfo.cpp
    carbongtkcellinfo.cpp
    carbongtkicons.cpp
    carbongtkrc.cpp
    carbongtktypenames.cpp
    carbongtkutils.cpp
    carbonloghandler.cpp
    carbonobjectcounter.cpp
    carbonobjectcountermap.cpp
    carbonoption.cpp
    carbonoptionmap.cpp
    carbonpalette.cpp
    carbonpathlist.cpp
    carbonpropertynames.cpp
    carbonqtsettings.cpp
    carbonrcstyle.cpp
    carbonrgba.cpp
    carbonshadowconfiguration.cpp
    carbonshadowhelper.cpp
    carbonstyle.cpp
    carbonstylehelper.cpp
    carbonstyleoptions.cpp
    carbonstylewrapper.cpp
    carbontaboptions.cpp
    carbontheme.cpp
    carbontileset.cpp
    carbonwindecobutton.cpp
    carbonwindecooptions.cpp
    carbonwindowmanager.cpp
    carbonwindowshadow.cpp
)

add_library( carbon-gtk SHARED ${carbon_gtk_SOURCES} )

# Add debug cflags
set( CMAKE_CXX_FLAGS " -Wall -g ${CMAKE_CXX_FLAGS}" )
set( CMAKE_C_FLAGS " -Wall -g ${CMAKE_C_FLAGS}" )

target_link_libraries( carbon-gtk ${GTK_LIBRARIES} ${CAIRO_LIBRARIES} ${X11_X11_LIB} )

install( TARGETS carbon-gtk DESTINATION ${INSTALL_PATH_GTK_ENGINES} )

=== debian/changelog ===
carbon-gtk2 (0+p20201123+git20201207.1945-0) 2101+amd64; urgency=medium

  * Automatic Debian CI Build

 -- Debian CI <null@debian.org>  Mon, 07 Dec 2020 19:45:51 +0000

carbon-gtk2 (0-1) unstable; urgency=medium

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- Rohan Garg <rohan@kde.org>  Mon, 25 Jul 2016 16:24:05 +0200

=== debian/control ===
Source: carbon-gtk2
Section: unknown
Priority: optional
Maintainer: Rohan Garg <rohan@kde.org>
Build-Depends: cmake,
               debhelper (>= 9),
               libcairo2-dev,
               libgtk2.0-dev,
               libx11-dev,
               pkg-config,
               pkg-kde-tools
Standards-Version: 3.9.8
Homepage: <insert the upstream URL, if relevant>
Vcs-Git: https://github.com/dci-extras-packaging/carbon-gtk2
Vcs-Browser: https://github.com/dci-extras-packaging/carbon-gtk2

Package: carbon-gtk2
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: carbon-gtk2 theme
 This package contains the carbon-gtk2 theme
